Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibAdditions.cpp	(revision 62882)
@@ -317,4 +317,5 @@
     /** @todo implement me */
     rc = VERR_NOT_IMPLEMENTED;
+    RT_NOREF1(ppszPath);
 #endif
     return rc;
Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibDaemonize.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibDaemonize.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3LibDaemonize.cpp	(revision 62882)
@@ -200,5 +200,8 @@
 
     if (!fNoChDir)
-        chdir("/");
+    {
+        int rcShutUpGcc = chdir("/");
+        RT_NOREF_PV(rcShutUpGcc);
+    }
 
     /*
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceAutoMount.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceAutoMount.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceAutoMount.cpp	(revision 62882)
@@ -322,5 +322,5 @@
         unsigned long fFlags = MS_NODEV;
 
-        const char *szOptions = { "rw" };
+        /*const char *szOptions = { "rw" }; - ??? */
         struct vbsf_mount_info_new mntinf;
 
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControl.cpp	(revision 62882)
@@ -78,8 +78,10 @@
 /** The guest control service client ID. */
 static uint32_t             g_uControlSvcClientID = 0;
+#if 0 /** @todo process limit */
 /** How many started guest processes are kept into memory for supplying
  *  information to the host. Default is 256 processes. If 0 is specified,
  *  the maximum number of processes is unlimited. */
 static uint32_t             g_uControlProcsMaxKept = 256;
+#endif
 /** List of guest control session threads (VBOXSERVICECTRLSESSIONTHREAD).
  *  A guest session thread represents a forked guest session process
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlProcess.cpp	(revision 62882)
@@ -50,6 +50,4 @@
 static int                  vgsvcGstCtrlProcessAssignPID(PVBOXSERVICECTRLPROCESS pThread, uint32_t uPID);
 static int                  vgsvcGstCtrlProcessLock(PVBOXSERVICECTRLPROCESS pProcess);
-static int                  vgsvcGstCtrlProcessRequest(PVBOXSERVICECTRLPROCESS pProcess, const PVBGLR3GUESTCTRLCMDCTX pHostCtx,
-                                                       PFNRT pfnFunction, unsigned cArgs, ...);
 static int                  vgsvcGstCtrlProcessSetupPipe(const char *pszHowTo, int fd, PRTHANDLE ph, PRTHANDLE *pph,
                                                          PRTPIPE phPipe);
@@ -304,4 +302,5 @@
 
 
+#ifdef DEBUG
 /**
  * Names a poll handle ID.
@@ -330,4 +329,5 @@
     }
 }
+#endif /* DEBUG */
 
 
@@ -847,4 +847,5 @@
 
 
+#if 0 /* unused */
 /**
  * Initializes a pipe's handle and pipe object.
@@ -865,4 +866,5 @@
     return VINF_SUCCESS;
 }
+#endif
 
 
@@ -1215,4 +1217,7 @@
                                             PRTPROCESS phProcess)
 {
+#ifndef RT_OS_WINDOWS
+    RT_NOREF1(pszDomain);
+#endif
     AssertPtrReturn(pszExec, VERR_INVALID_PARAMETER);
     AssertPtrReturn(papszArgs, VERR_INVALID_PARAMETER);
Index: /trunk/src/VBox/Additions/common/pam/pam_vbox.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/pam/pam_vbox.cpp	(revision 62881)
+++ /trunk/src/VBox/Additions/common/pam/pam_vbox.cpp	(revision 62882)
@@ -120,4 +120,5 @@
 static void pam_vbox_error(pam_handle_t *hPAM, const char *pszFormat, ...)
 {
+    RT_NOREF1(hPAM);
     va_list va;
     char *buf;
@@ -141,4 +142,5 @@
 static void pam_vbox_log(pam_handle_t *hPAM, const char *pszFormat, ...)
 {
+    RT_NOREF1(hPAM);
     if (g_verbosity)
     {
@@ -305,4 +307,5 @@
 static void pam_vbox_shutdown(pam_handle_t *hPAM)
 {
+    RT_NOREF1(hPAM);
     VbglR3Term();
 }
@@ -552,10 +555,11 @@
  *
  * @return  IPRT status code.
- * @param   ThreadSelf              Thread struct to this thread.
+ * @param   hThreadSelf             Thread handle.
  * @param   pvUser                  Pointer to a PAMVBOXTHREAD structure providing
  *                                  required data used / set by the thread.
  */
-static DECLCALLBACK(int) pam_vbox_wait_thread(RTTHREAD ThreadSelf, void *pvUser)
-{
+static DECLCALLBACK(int) pam_vbox_wait_thread(RTTHREAD hThreadSelf, void *pvUser)
+{
+    RT_NOREF1(hThreadSelf);
     PPAMVBOXTHREAD pUserData = (PPAMVBOXTHREAD)pvUser;
     AssertPtr(pUserData);
@@ -677,4 +681,5 @@
 static int pam_vbox_wait_for_creds(pam_handle_t *hPAM, uint32_t uClientID, uint32_t uTimeoutMS)
 {
+    RT_NOREF1(uClientID);
     PAMVBOXTHREAD threadData;
     threadData.hPAM = hPAM;
@@ -702,7 +707,8 @@
 
 
-DECLEXPORT(int) pam_sm_authenticate(pam_handle_t *hPAM, int iFlags,
-                                    int argc, const char **argv)
-{
+DECLEXPORT(int) pam_sm_authenticate(pam_handle_t *hPAM, int iFlags, int argc, const char **argv)
+{
+    RT_NOREF1(iFlags);
+
     /* Parse arguments. */
     for (int i = 0; i < argc; i++)
@@ -848,4 +854,5 @@
 DECLEXPORT(int) pam_sm_acct_mgmt(pam_handle_t *hPAM, int iFlags, int argc, const char **argv)
 {
+    RT_NOREF3(iFlags, argc, argv);
     pam_vbox_log(hPAM, "pam_vbox_acct_mgmt called\n");
     return PAM_SUCCESS;
@@ -855,4 +862,5 @@
 DECLEXPORT(int) pam_sm_open_session(pam_handle_t *hPAM, int iFlags, int argc, const char **argv)
 {
+    RT_NOREF3(iFlags, argc, argv);
     pam_vbox_log(hPAM, "pam_vbox_open_session called\n");
     RTPrintf("This session was provided by VirtualBox Guest Additions. Have a lot of fun!\n");
@@ -863,4 +871,5 @@
 DECLEXPORT(int) pam_sm_close_session(pam_handle_t *hPAM, int iFlags, int argc, const char **argv)
 {
+    RT_NOREF3(iFlags, argc, argv);
     pam_vbox_log(hPAM, "pam_vbox_close_session called\n");
     return PAM_SUCCESS;
@@ -870,4 +879,5 @@
 DECLEXPORT(int) pam_sm_chauthtok(pam_handle_t *hPAM, int iFlags, int argc, const char **argv)
 {
+    RT_NOREF3(iFlags, argc, argv);
     pam_vbox_log(hPAM, "pam_vbox_sm_chauthtok called\n");
     return PAM_SUCCESS;