Index: /trunk/src/VBox/Devices/Graphics/shaderlib/directx.c
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/directx.c	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/directx.c	(revision 62948)
@@ -252,5 +252,5 @@
     GL_EXTCALL(glBindProgramARB(GL_VERTEX_PROGRAM_ARB, prog));
     GL_EXTCALL(glProgramStringARB(GL_VERTEX_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB,
-                                  strlen(testcode), testcode));
+                                  (GLsizei)strlen(testcode), testcode));
     if(glGetError() != 0) {
         TRACE("OpenGL implementation does not allow indirect addressing offsets > 63\n");
@@ -494,5 +494,5 @@
     GL_EXTCALL(glBindProgramARB(GL_VERTEX_PROGRAM_ARB, prog));
     GL_EXTCALL(glProgramStringARB(GL_VERTEX_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB,
-                                  strlen(testcode), testcode));
+                                  (GLsizei)strlen(testcode), testcode));
     glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB, &pos);
     if(pos != -1)
@@ -1928,5 +1928,7 @@
 BOOL IWineD3DImpl_FillGLCaps(struct wined3d_adapter *adapter, struct VBOXVMSVGASHADERIF *pVBoxShaderIf)
 {
+#ifndef VBOX_WITH_VMSVGA
     struct wined3d_driver_info *driver_info = &adapter->driver_info;
+#endif
     struct wined3d_gl_info *gl_info = &adapter->gl_info;
 #ifndef VBOX_WITH_VMSVGA
@@ -1935,5 +1937,7 @@
 #endif
     const char *gl_vendor_str, *gl_renderer_str, *gl_version_str;
+#ifndef VBOX_WITH_VMSVGA
     struct fragment_caps fragment_caps;
+#endif
     enum wined3d_gl_vendor gl_vendor;
     enum wined3d_pci_vendor card_vendor;
@@ -1942,8 +1946,12 @@
     GLfloat     gl_floatv[2];
     unsigned    i;
+#ifndef VBOX_WITH_VMSVGA
     HDC         hdc;
+#endif
     unsigned int vidmem=0;
     DWORD gl_version;
+#ifndef VBOX_WITH_VMSVGA
     size_t len;
+#endif
 
     TRACE_(d3d_caps)("(%p)\n", gl_info);
@@ -2074,5 +2082,5 @@
             check_gl_extension(gl_info, szCurExt);
     }
-#else /* VBOX_WITH_VMSVGA */
+#else /* !VBOX_WITH_VMSVGA */
     while (*GL_Extensions)
     {
@@ -2101,5 +2109,5 @@
         }
     }
-#endif
+#endif /* !VBOX_WITH_VMSVGA */
 
 #ifdef VBOX_WITH_VMSVGA
Index: /trunk/src/VBox/Devices/Graphics/shaderlib/glsl_shader.c
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/glsl_shader.c	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/glsl_shader.c	(revision 62948)
@@ -2014,5 +2014,5 @@
     {
         enum complex_fixup complex_fixup = get_complex_fixup(fixup);
-        FIXME("Complex fixup (%#x) not supported\n",complex_fixup);
+        FIXME("Complex fixup (%#x) not supported\n",complex_fixup); (void)complex_fixup;
         return;
     }
@@ -3640,6 +3640,6 @@
 static void shader_glsl_texbem(const struct wined3d_shader_instruction *ins)
 {
-    IWineD3DBaseShaderImpl *shader = (IWineD3DBaseShaderImpl *)ins->ctx->shader;
-    IWineD3DDeviceImpl *deviceImpl = (IWineD3DDeviceImpl *)shader->baseShader.device;
+    /*IWineD3DBaseShaderImpl *shader = (IWineD3DBaseShaderImpl *)ins->ctx->shader;
+    IWineD3DDeviceImpl *deviceImpl = (IWineD3DDeviceImpl *)shader->baseShader.device; - unused */
     const struct wined3d_gl_info *gl_info = ins->ctx->gl_info;
     const struct shader_glsl_ctx_priv *priv = ins->ctx->backend_data;
Index: /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/debug.c
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/debug.c	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/debug.c	(revision 62948)
@@ -177,5 +177,5 @@
             for (i = 0; i < sizeof(debug_classes)/sizeof(debug_classes[0]); i++)
             {
-                int len = strlen(debug_classes[i]);
+                int len = (int)strlen(debug_classes[i]);
                 if (len != (p - opt)) continue;
                 if (!memcmp( opt, debug_classes[i], len ))  /* found it */
@@ -318,5 +318,5 @@
 int interlocked_xchg_add( int *dest, int incr )
 {
-    return InterlockedExchangeAdd(dest, incr);
+    return InterlockedExchangeAdd((LONG *)dest, incr);
 }
 #endif
@@ -347,5 +347,5 @@
 static const char *default_dbgstr_an( const char *str, int n )
 {
-    static const char hex[16] = "0123456789abcdef";
+    static const char hex[16+1] = "0123456789abcdef";
     char *dst, *res;
     size_t size;
@@ -358,5 +358,5 @@
         return res;
     }
-    if (n == -1) n = strlen(str);
+    if (n == -1) n = (int)strlen(str);
     if (n < 0) n = 0;
     size = 10 + min( 300, n * 4 );
Index: /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/include/wine/debug.h
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/include/wine/debug.h	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/libWineStub/include/wine/debug.h	(revision 62948)
@@ -315,7 +315,7 @@
 
 #define WINE_DECLARE_DEBUG_CHANNEL(ch) \
-    static struct __wine_debug_channel __wine_dbch_##ch = { ~0, #ch }
+    static struct __wine_debug_channel __wine_dbch_##ch = { /* was: ~0, VBox:*/ UINT8_MAX, #ch }
 #define WINE_DEFAULT_DEBUG_CHANNEL(ch) \
-    static struct __wine_debug_channel __wine_dbch_##ch = { ~0, #ch }; \
+    static struct __wine_debug_channel __wine_dbch_##ch = { /* was: ~0, VBox:*/ UINT8_MAX, #ch }; \
     static struct __wine_debug_channel * const __wine_dbch___default = &__wine_dbch_##ch
 
Index: /trunk/src/VBox/Devices/Graphics/shaderlib/shader_sm1.c
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/shader_sm1.c	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/shader_sm1.c	(revision 62948)
@@ -424,5 +424,5 @@
     while (opcode_table[i].handler_idx != WINED3DSIH_TABLE_SIZE)
     {
-        if ((code & WINED3DSI_OPCODE_MASK) == opcode_table[i].opcode
+        if ((code & WINED3DSI_OPCODE_MASK) == (DWORD)opcode_table[i].opcode
                 && shader_version >= opcode_table[i].min_version
                 && (!opcode_table[i].max_version || shader_version <= opcode_table[i].max_version))
Index: /trunk/src/VBox/Devices/Graphics/shaderlib/wined3d_private.h
===================================================================
--- /trunk/src/VBox/Devices/Graphics/shaderlib/wined3d_private.h	(revision 62947)
+++ /trunk/src/VBox/Devices/Graphics/shaderlib/wined3d_private.h	(revision 62948)
@@ -47,5 +47,5 @@
 #include "winuser.h"
 #else
-#include <iprt/win/windows.h>
+# include <iprt/win/windows.h>
 #endif
 #include "wine/debug.h"
Index: /trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Devices/Makefile.kmk	(revision 62947)
+++ /trunk/src/VBox/Devices/Makefile.kmk	(revision 62948)
@@ -1453,4 +1453,9 @@
  	-install_name $(VBOX_DYLD_EXECUTABLE_PATH)/VBoxSVGA3D.dylib
  $(call VBOX_SET_VER_INFO_DLL,VBoxSVGA3D,VirtualBox VMSVGA 3D)
+ #  -wd4100: unreferenced format parameter
+ #  -wd4204: nonstandard extension used : non-constant initializer
+ #  -wd4245: '=' : conversion from 'int' to 'DWORD', signed/unsigned mismatch
+ #  -wd4305: 'function' : truncation from 'double' to 'GLclampf'
+ VBoxSVGA3D_CFLAGS.win = -wd4100  -wd4204 -wd4245 -wd4305
 
  #