Index: trunk/src/VBox/Devices/Network/slirp/bsd/amd64/in_cksum.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/bsd/amd64/in_cksum.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/bsd/amd64/in_cksum.c	(revision 63015)
@@ -103,5 +103,5 @@
 	union q_util q_util;
 
-	if ((3 & (long) lw) == 0 && len == 20) {
+	if ((3 & (intptr_t) lw) == 0 && len == 20) {
 	     sum = (u_int64_t) lw[0] + lw[1] + lw[2] + lw[3] + lw[4];
 	     REDUCE32;
@@ -109,5 +109,5 @@
 	}
 
-	if ((offset = 3 & (long) lw) != 0) {
+	if ((offset = 3 & (intptr_t) lw) != 0) {
 		const u_int32_t *masks = in_masks + (offset << 2);
 		lw = (u_int32_t *) (((RTHCUINTPTR) lw) - offset);
@@ -225,5 +225,5 @@
 		if (len < mlen)
 			mlen = len;
-		if ((clen ^ (long) addr) & 1)
+		if ((clen ^ (intptr_t) addr) & 1)
 		    sum += in_cksumdata(addr, mlen) << 8;
 		else
Index: trunk/src/VBox/Devices/Network/slirp/bsd/kern/kern_mbuf.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/bsd/kern/kern_mbuf.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/bsd/kern/kern_mbuf.c	(revision 63015)
@@ -529,11 +529,11 @@
 {
 	struct mbuf *m;
-	unsigned long flags;
+	uintptr_t flags;
 #ifdef VBOX
-    NOREF(pData);
+	NOREF(pData);
 #endif
 
 	m = (struct mbuf *)mem;
-	flags = (unsigned long)arg;
+	flags = (uintptr_t)arg;
 
 	if ((flags & MB_NOTAGS) == 0 && (m->m_flags & M_PKTHDR) != 0)
@@ -544,6 +544,6 @@
 	trash_dtor(mem, size, arg);
 #elif defined(VBOX)
-    NOREF(size);
-    NOREF(arg);
+	NOREF(size);
+	NOREF(arg);
 #endif
 }
Index: trunk/src/VBox/Devices/Network/slirp/bsd/kern/uipc_mbuf.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/bsd/kern/uipc_mbuf.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/bsd/kern/uipc_mbuf.c	(revision 63015)
@@ -269,5 +269,5 @@
 	/* Free attached storage if this mbuf is the only reference to it. */
 	if (*(m->m_ext.ref_cnt) == 1 ||
-	    atomic_fetchadd_int(m->m_ext.ref_cnt, -1) == 1) {
+	    atomic_fetchadd_int(m->m_ext.ref_cnt, (uint32_t)-1) == 1) {
 		switch (m->m_ext.ext_type) {
 		case EXT_PACKET:	/* The packet zone is special. */
@@ -434,5 +434,5 @@
 				m_freem(pData, m->m_nextpkt);
 #endif
-				m->m_nextpkt = (struct mbuf *)0xDEADC0DE;
+				m->m_nextpkt = (struct mbuf *)(uintptr_t)UINT32_C(0xDEADC0DE);
 			} else
 				M_SANITY_ACTION("m->m_nextpkt on in-chain mbuf");
Index: trunk/src/VBox/Devices/Network/slirp/libalias/alias_ftp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/libalias/alias_ftp.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/libalias/alias_ftp.c	(revision 63015)
@@ -182,5 +182,5 @@
     handlers[0].fingerprint = &fingerprint;
     handlers[0].protohandler = &protohandler;
-    handlers[1].pri = EOH;
+    handlers[1].pri = (u_int)EOH;
 #endif /* VBOX */
 
@@ -728,5 +728,5 @@
 
 /* Save string length for IP header modification */
-            slen = strlen(stemp);
+            slen = (int)strlen(stemp);
 
 /* Copy modified buffer into IP packet. */
Index: trunk/src/VBox/Devices/Network/slirp/libalias/alias_nbt.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/libalias/alias_nbt.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/libalias/alias_nbt.c	(revision 63015)
@@ -219,5 +219,5 @@
     handlers[2].protohandler = &protohandler2out;
 
-    handlers[3].pri = EOH;
+    handlers[3].pri = (u_int)EOH;
 #endif /* VBOX */
 
Index: trunk/src/VBox/Devices/Network/slirp/libalias/alias_proxy.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/libalias/alias_proxy.c	(revision 63014)
+++ trunk/src/VBox/Devices/Network/slirp/libalias/alias_proxy.c	(revision 63015)
@@ -427,5 +427,5 @@
 
 /* Pad string out to a multiple of two in length */
-    slen = strlen(buffer);
+    slen = (int)strlen(buffer);
     switch (slen % 2) {
     case 0:
@@ -693,5 +693,5 @@
 /* Copy command line into a buffer */
     cmd += strspn(cmd, " \t");
-    cmd_len = strlen(cmd);
+    cmd_len = (int)strlen(cmd);
     if (cmd_len > (int)(sizeof(buffer) - 1)) {
         ret = -1;
@@ -701,5 +701,5 @@
 
 /* Convert to lower case */
-    len = strlen(buffer);
+    len = (int)strlen(buffer);
     for (i = 0; i < len; i++)
         buffer[i] = tolower((unsigned char)buffer[i]);