Index: trunk/src/VBox/Runtime/r0drv/nt/memobj-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/memobj-r0drv-nt.cpp	(revision 63062)
+++ trunk/src/VBox/Runtime/r0drv/nt/memobj-r0drv-nt.cpp	(revision 63063)
@@ -523,4 +523,5 @@
     return VERR_NO_MEMORY;
 #else   /* IPRT_TARGET_NT4 */
+    RT_NOREF(ppMem, cb, PhysHighest);
     return VERR_NOT_SUPPORTED;
 #endif  /* IPRT_TARGET_NT4 */
Index: trunk/src/VBox/Runtime/r0drv/nt/mp-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/mp-r0drv-nt.cpp	(revision 63062)
+++ trunk/src/VBox/Runtime/r0drv/nt/mp-r0drv-nt.cpp	(revision 63063)
@@ -374,21 +374,21 @@
                              RT_NT_CPUID enmCpuid, RTCPUID idCpu, RTCPUID idCpu2, uint32_t *pcHits)
 {
+#ifdef IPRT_TARGET_NT4
+    RT_NOREF(pfnWorker, pvUser1, pvUser2, enmCpuid, idCpu, idCpu2, pcHits);
+    /* g_pfnrtNt* are not present on NT anyway. */
+    return VERR_NOT_SUPPORTED;
+
+#else  /* !IPRT_TARGET_NT4 */
     PRTMPARGS pArgs;
     KDPC     *paExecCpuDpcs;
 
-#if 0
+# if 0
     /* KeFlushQueuedDpcs must be run at IRQL PASSIVE_LEVEL according to MSDN, but the
      * driver verifier doesn't complain...
      */
     AssertMsg(KeGetCurrentIrql() == PASSIVE_LEVEL, ("%d != %d (PASSIVE_LEVEL)\n", KeGetCurrentIrql(), PASSIVE_LEVEL));
-#endif
-
-#ifdef IPRT_TARGET_NT4
-    KAFFINITY Mask;
-    /* g_pfnrtNt* are not present on NT anyway. */
-    return VERR_NOT_SUPPORTED;
-#else
+# endif
+
     KAFFINITY Mask = KeQueryActiveProcessors();
-#endif
 
     /* KeFlushQueuedDpcs is not present in Windows 2000; import it dynamically so we can just fail this call. */
@@ -505,4 +505,5 @@
 
     return VINF_SUCCESS;
+#endif /* */
 }
 
Index: trunk/src/VBox/Runtime/r0drv/nt/timer-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/timer-r0drv-nt.cpp	(revision 63062)
+++ trunk/src/VBox/Runtime/r0drv/nt/timer-r0drv-nt.cpp	(revision 63063)
@@ -130,5 +130,5 @@
         InterruptTime.HighPart = ((KUSER_SHARED_DATA volatile *)SharedUserData)->InterruptTime.High1Time;
         InterruptTime.LowPart  = ((KUSER_SHARED_DATA volatile *)SharedUserData)->InterruptTime.LowPart;
-    } while (((KUSER_SHARED_DATA volatile *)SharedUserData)->InterruptTime.High2Time != InterruptTime.HighPart);
+    } while (((KUSER_SHARED_DATA volatile *)SharedUserData)->InterruptTime.High2Time != (LONG)InterruptTime.HighPart);
     return InterruptTime.QuadPart;
 # endif
Index: trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 63062)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 63063)
@@ -263,5 +263,5 @@
         MyDisBlock(enmDisCpuMode, (uintptr_t)pbCode,
                    RT_MAX(NearSym.aSyms[1].Value - NearSym.aSyms[0].Value, 0x20000),
-                   NearSym.aSyms[0].Value - (RTUINTPTR)pbCode,
+                   NearSym.aSyms[0].Value - (uintptr_t)pbCode,
                    NearSym.aSyms[0].Value,
                    NearSym.Addr);
Index: trunk/src/VBox/Runtime/testcase/tstRTStrFormat.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTStrFormat.cpp	(revision 63062)
+++ trunk/src/VBox/Runtime/testcase/tstRTStrFormat.cpp	(revision 63063)
@@ -473,17 +473,18 @@
     }
 
-    if (sizeof(RTCCUINTREG) == 8)
-    {
-        CHECK42("%RTreg", (RTCCUINTREG)0, "0000000000000000");
-        CHECK42("%RTreg", ~(RTCCUINTREG)0, "ffffffffffffffff");
-        CHECK42("%RTreg", (RTCCUINTREG)0x84342134, "0000000084342134");
-        CHECK42("%RTreg", (RTCCUINTREG)0x23484342134ULL, "0000023484342134");
-    }
-    else
-    {
-        CHECK42("%RTreg", (RTCCUINTREG)0, "00000000");
-        CHECK42("%RTreg", ~(RTCCUINTREG)0, "ffffffff");
-        CHECK42("%RTreg", (RTCCUINTREG)0x84342134, "84342134");
-    }
+#if ARCH_BITS == 64
+    AssertCompileSize(RTCCUINTREG, 8);
+    CHECK42("%RTreg", (RTCCUINTREG)0, "0000000000000000");
+    CHECK42("%RTreg", ~(RTCCUINTREG)0, "ffffffffffffffff");
+    CHECK42("%RTreg", (RTCCUINTREG)0x84342134, "0000000084342134");
+    CHECK42("%RTreg", (RTCCUINTREG)0x23484342134ULL, "0000023484342134");
+#elif ARCH_BITS == 32
+    AssertCompileSize(RTCCUINTREG, 4);
+    CHECK42("%RTreg", (RTCCUINTREG)0, "00000000");
+    CHECK42("%RTreg", ~(RTCCUINTREG)0, "ffffffff");
+    CHECK42("%RTreg", (RTCCUINTREG)0x84342134, "84342134");
+#else
+# error ARCH_BITS
+#endif
 
     CHECK42("%RTsel", (RTSEL)0x543, "0543");